#include "lcd.h"
#include "stdlib.h"
#include "usart.h"
#include "delay.h"	
#include "tp.h"

#ifdef TP_TEST


void TP_Write(unsigned char cmd)
{
	unsigned char  i;

	TP_CS_CLR ;
	TP_DCLK_CLR;

	for(i=0;i<8;i++)
	{
		if((cmd&0x80)==0)
		TP_DIN_CLR;
		else
		TP_DIN_SET;
		TP_DCLK_SET;
		cmd=cmd<<1;
		TP_DCLK_CLR;//be low ,before read
	}
}

unsigned int TP_Read(void)
{
	unsigned char  i;
	 int 	val=0;

	TP_CS_CLR ;
	TP_DOUT_SET;

	for(i=0;i<12;i++)
	{
		TP_DCLK_CLR;
		//if(TP_DOUT)
		{
			val=val|(1<<(11-i));
		}
		TP_DCLK_SET;
	}

	TP_CS_SET;
	return val;
}

unsigned int TP_GetPosition(unsigned char cmd)
{
	unsigned int  temp;
	unsigned char  i=0,j=0,k=0;
	unsigned int   TP[11];

	TP_PENIRQ_SET;

	//while((i<11)&&(!TP_PENIRQ))
	{
		TP_CS_CLR ;
		TP_Write(cmd+1);
		TP[i]=TP_Read();
		i++;
		TP_CS_SET;
	}
	if(i!=0)
	{
		for(j=0;j<i;j++)
			for(k=0;k<i-j;k++)
				if (*(TP+k)>*(TP+k+1))
					{
					temp=*(TP+k);
					*(TP+k)=*(TP+k+1);
					*(TP+k+1)=temp;
				}
		return (TP[i/2]);
	}
	else
		return 0;
}

void TP_DrawLine(void)
{
	unsigned  int   gx=0,gy=0;           //coordinate on glass
	unsigned  int   tx=0,ty=0;           //coordinate value read from TP
	unsigned  int   gxtemp=0,gytemp=0;            //coordinate on glass

	DispColor(BLACK);
	DrawGird(GRAY25);
	//DispStr("TP TEST",0,0,BLACK,WHITE);

	TP_PENIRQ_SET;
	//while (TP_PENIRQ) ;

	while(1)
	{

		//while(KEY_STEP)
		{
			//Delay(50);//!
			//while(!TP_PENIRQ)
			{


				tx=TP_GetPosition(0xd0);//x-position measure
				gx=(tx-X_min)*(unsigned long int)(240)/((X_max-X_min));
			
				ty=TP_GetPosition(0x90);//y-position measure
				gy=(ty-Y_min)*(unsigned long int)(320)/((Y_max-Y_min));
			
				delay_ms(5000);
		
				//touch panel must be interrupted
			//	if((!TP_PENIRQ)&&(gx>=0&&gx<COL)&&(gy>=0&&gy<ROW))
				{
				//	PutPixel((gx),(320-gy),RED);
				}
			}
			delay_ms(5000);
		}

		DispColor(BLACK);
		DrawGird(GRAY25);
		
	//	DispStr("TP TEST",0,0,BLACK,WHITE);

	}

}

#endif




